#pragma once

#include <SDL2/SDL_render.h> // for SDL_Renderer
#include <SDL2/SDL_stdinc.h> // for Uint32
#include <memory>			 // for shared_ptr
#include <vector>			 // for vector
#include "utils.h"			 // for Color
class Asset;				 // lines 8-8
class Input;				 // lines 9-9
class Resource;				 // lines 10-10
class Screen;				 // lines 11-11
class Sprite;				 // lines 12-12
class Texture;				 // lines 13-13

class Logo
{
private:
	// Constantes
	static constexpr int INIT_FADE_ = 300; // Tiempo del contador cuando inicia el fade a negro
	static constexpr int END_LOGO_ = 400;  // Tiempo del contador para terminar el logo
	static constexpr int POST_LOGO_ = 20;  // Tiempo que dura el logo con el fade al maximo

	// Objetos y punteros
	std::shared_ptr<Texture> jailgames_texture_;			// Textura con los graficos "JAILGAMES"
	std::shared_ptr<Texture> since_1998_texture_;			// Textura con los graficos "Since 1998"
	std::vector<std::shared_ptr<Sprite>> jailgames_sprite_; // Vector con los sprites de cada linea que forman el bitmap JAILGAMES
	std::shared_ptr<Sprite> since_1998_sprite_;				// Sprite para manejar la textura2

	// Variables
	std::vector<Color> color_; // Vector con los colores para el fade
	int counter_ = 0;		   // Contador
	Uint32 ticks_ = 0;		   // Contador de ticks para ajustar la velocidad del programa

	// Actualiza las variables
	void update();

	// Dibuja en pantalla
	void render();

	// Comprueba el manejador de eventos
	void checkEvents();

	// Comprueba las entradas
	void checkInput();

	// Gestiona el logo de JAILGAME
	void updateJAILGAMES();

	// Gestiona el color de las texturas
	void updateTextureColors();

	// Termina la sección
	void endSection();

public:
	// Constructor
	Logo();

	// Destructor
	~Logo() = default;

	// Bucle principal
	void run();
};